//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 23-1
//
// Blinks the red LED at a one Hz rate, the green LED at a 4 Hz rate, and
// displays "Button Pressed" when the button is pressed.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>

#use rtos(timer=0,minor_cycle=50ms)

int8 sem_btn = 0;

#int_ext1
void ext1_isr(void) {
   rtos_signal(sem_btn);
   delay_ms(50);
}

#task(rate=1000ms,max=1ms)
void task_one() {
   output_toggle(PIN_C3);
}

#task(rate=250ms,max=1ms)
void task_two() {
   output_toggle(PIN_C6);
}

#task(rate=200ms)
void task_three() {
   rtos_wait(sem_btn);
   // Signal Button
   printf("\r\nButton Pressed");
}

void main(vodi) {
   enable_interrupts(INT_EXT1_L2H);
   enable_interrupts(GLOBAL);
   rtos_run();
   for(;;);
}
